# coding: utf-8

"""
    Vantage API

    This is a the API to interact with Vantage Discovery, the amazing Semantic Search Platform in the world.  We enable developers to build magical discovery experiences into their products and websites.  Some useful links: - [TODO: Semantic Search Guide: What Is It And Why Does It Matter?](https://www.bloomreach.com/en/blog/2019/semantic-search-explained-in-5-minutes)

    The version of the OpenAPI document: v1.1.2
    Contact: devrel@vantagediscovery.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional

from pydantic import BaseModel

from vantage_sdk.core.http.models.search_options_filter_boolean_filter import (
    SearchOptionsFilterBooleanFilter,
)


try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class SearchOptionsFilter(BaseModel):
    """
    SearchOptionsFilter
    """  # noqa: E501

    boolean_filter: Optional[SearchOptionsFilterBooleanFilter] = None
    variant_filter: Optional[SearchOptionsFilterBooleanFilter] = None
    __properties: ClassVar[List[str]] = ["boolean_filter", "variant_filter"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SearchOptionsFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={},
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of boolean_filter
        if self.boolean_filter:
            _dict['boolean_filter'] = self.boolean_filter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of variant_filter
        if self.variant_filter:
            _dict['variant_filter'] = self.variant_filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SearchOptionsFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "boolean_filter": SearchOptionsFilterBooleanFilter.from_dict(
                    obj.get("boolean_filter")
                )
                if obj.get("boolean_filter") is not None
                else None,
                "variant_filter": SearchOptionsFilterBooleanFilter.from_dict(
                    obj.get("variant_filter")
                )
                if obj.get("variant_filter") is not None
                else None,
            }
        )
        return _obj
